import _extends from 'babel-runtime/helpers/extends';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { PureComponent } from 'react';
import { StyleSheet, Text } from 'react-native';
import { TabViewAnimated, TabBar, SceneMap } from 'react-native-tab-view';
import tabsStyle from './style/index.native';
var tabsStyles = StyleSheet.create(tabsStyle);
export var TabPane = function (_React$Component) {
    _inherits(TabPane, _React$Component);

    function TabPane() {
        _classCallCheck(this, TabPane);

        return _possibleConstructorReturn(this, (TabPane.__proto__ || Object.getPrototypeOf(TabPane)).apply(this, arguments));
    }

    _createClass(TabPane, [{
        key: 'render',
        value: function render() {
            return null;
        }
    }]);

    return TabPane;
}(React.Component);

var Tabs = function (_PureComponent) {
    _inherits(Tabs, _PureComponent);

    function Tabs(props) {
        _classCallCheck(this, Tabs);

        var _this2 = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

        _this2.handleIndexChange = function (index) {
            _this2.setState({ index: index });
            if (_this2.props.onChange) {
                var key = _this2.state.routes[index].key;
                _this2.props.onChange(key);
            }
        };
        _this2.onTabClick = function (scene) {
            if (_this2.props.onTabClick) {
                _this2.props.onTabClick(scene.route.key);
            }
        };
        _this2.renderLabel = function (scene) {
            var _this2$props = _this2.props,
                styles = _this2$props.styles,
                textColor = _this2$props.textColor,
                activeTextColor = _this2$props.activeTextColor;

            var tabStatusStyles = scene.focused ? [styles.activeTabText, {
                color: activeTextColor
            }] : [styles.inactiveTabText, {
                color: textColor
            }];
            var title = scene.route.title;
            return typeof title === 'string' ? React.createElement(
                Text,
                { style: [styles.tabText].concat(tabStatusStyles) },
                title
            ) : title;
        };
        _this2._renderBar = function (props) {
            var _ref2;

            var _this2$props2 = _this2.props,
                barStyle = _this2$props2.barStyle,
                styles = _this2$props2.styles,
                tabBarPosition = _this2$props2.tabBarPosition,
                activeUnderlineColor = _this2$props2.activeUnderlineColor,
                underlineColor = _this2$props2.underlineColor;

            var barProps = {
                onTabPress: _this2.onTabClick,
                renderLabel: _this2.renderLabel,
                style: [styles.bar, styles[tabBarPosition === 'top' ? 'barTop' : 'barBottom'], _defineProperty({}, tabBarPosition === 'top' ? 'borderBottomColor' : 'borderTopColor', underlineColor), barStyle],
                tabStyle: styles.tab,
                indicatorStyle: [styles.underline, (_ref2 = {}, _defineProperty(_ref2, tabBarPosition === 'top' ? 'bottom' : 'top', -1), _defineProperty(_ref2, 'backgroundColor', activeUnderlineColor), _ref2)]
            };
            return React.createElement(TabBar, _extends({}, props, barProps));
        };
        var routes = _this2.getRoutes(props);
        _this2.state = {
            index: _this2.getIndexFromKey(),
            routes: routes
        };
        return _this2;
    }

    _createClass(Tabs, [{
        key: 'getRoutes',
        value: function getRoutes(props) {
            return React.Children.map(props.children, function (child, idx) {
                return {
                    key: child.key || '' + idx,
                    title: child.props.tab || 'Option' + idx,
                    scene: function scene() {
                        return child.props.children;
                    }
                };
            });
        }
    }, {
        key: 'getIndexFromKey',
        value: function getIndexFromKey() {
            var _props = this.props,
                activeKey = _props.activeKey,
                defaultActiveKey = _props.defaultActiveKey;

            var key = activeKey || defaultActiveKey;
            if (!key) {
                return 0;
            }
            var routes = this.getRoutes(this.props);
            return routes.findIndex(function (r) {
                return r.key === key;
            });
        }
    }, {
        key: 'getScenes',
        value: function getScenes() {
            var routes = this.getRoutes(this.props);
            var scenes = {};
            routes.forEach(function (route) {
                scenes['' + route.key] = route.scene;
            });
            return scenes;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                animated = _props2.animated,
                swipeable = _props2.swipeable,
                tabBarPosition = _props2.tabBarPosition;

            var postionRender = _defineProperty({}, tabBarPosition === 'top' ? 'renderHeader' : 'renderFooter', this._renderBar);
            return React.createElement(TabViewAnimated, _extends({ navigationState: this.state, renderScene: SceneMap(this.getScenes()), onIndexChange: this.handleIndexChange, animationEnabled: animated, swipeEnabled: swipeable }, postionRender));
        }
    }]);

    return Tabs;
}(PureComponent);

Tabs.defaultProps = {
    tabBarPosition: 'top',
    animated: true,
    swipeable: true,
    onChange: function onChange() {},
    onTabClick: function onTabClick() {},

    underlineColor: '#ddd',
    activeUnderlineColor: '#108ee9',
    textColor: '#000',
    activeTextColor: '#108ee9',
    styles: tabsStyles,
    barStyle: null
};
Tabs.TabPane = TabPane;
export default Tabs;