'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TabPane = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _reactNativeTabView = require('react-native-tab-view');

var _index = require('./style/index.native');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var tabsStyles = _reactNative.StyleSheet.create(_index2['default']);

var TabPane = exports.TabPane = function (_React$Component) {
    (0, _inherits3['default'])(TabPane, _React$Component);

    function TabPane() {
        (0, _classCallCheck3['default'])(this, TabPane);
        return (0, _possibleConstructorReturn3['default'])(this, (TabPane.__proto__ || Object.getPrototypeOf(TabPane)).apply(this, arguments));
    }

    (0, _createClass3['default'])(TabPane, [{
        key: 'render',
        value: function render() {
            return null;
        }
    }]);
    return TabPane;
}(_react2['default'].Component);

var Tabs = function (_PureComponent) {
    (0, _inherits3['default'])(Tabs, _PureComponent);

    function Tabs(props) {
        (0, _classCallCheck3['default'])(this, Tabs);

        var _this2 = (0, _possibleConstructorReturn3['default'])(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

        _this2.handleIndexChange = function (index) {
            _this2.setState({ index: index });
            if (_this2.props.onChange) {
                var key = _this2.state.routes[index].key;
                _this2.props.onChange(key);
            }
        };
        _this2.onTabClick = function (scene) {
            if (_this2.props.onTabClick) {
                _this2.props.onTabClick(scene.route.key);
            }
        };
        _this2.renderLabel = function (scene) {
            var _this2$props = _this2.props,
                styles = _this2$props.styles,
                textColor = _this2$props.textColor,
                activeTextColor = _this2$props.activeTextColor;

            var tabStatusStyles = scene.focused ? [styles.activeTabText, {
                color: activeTextColor
            }] : [styles.inactiveTabText, {
                color: textColor
            }];
            var title = scene.route.title;
            return typeof title === 'string' ? _react2['default'].createElement(
                _reactNative.Text,
                { style: [styles.tabText].concat(tabStatusStyles) },
                title
            ) : title;
        };
        _this2._renderBar = function (props) {
            var _ref2;

            var _this2$props2 = _this2.props,
                barStyle = _this2$props2.barStyle,
                styles = _this2$props2.styles,
                tabBarPosition = _this2$props2.tabBarPosition,
                activeUnderlineColor = _this2$props2.activeUnderlineColor,
                underlineColor = _this2$props2.underlineColor;

            var barProps = {
                onTabPress: _this2.onTabClick,
                renderLabel: _this2.renderLabel,
                style: [styles.bar, styles[tabBarPosition === 'top' ? 'barTop' : 'barBottom'], (0, _defineProperty3['default'])({}, tabBarPosition === 'top' ? 'borderBottomColor' : 'borderTopColor', underlineColor), barStyle],
                tabStyle: styles.tab,
                indicatorStyle: [styles.underline, (_ref2 = {}, (0, _defineProperty3['default'])(_ref2, tabBarPosition === 'top' ? 'bottom' : 'top', -1), (0, _defineProperty3['default'])(_ref2, 'backgroundColor', activeUnderlineColor), _ref2)]
            };
            return _react2['default'].createElement(_reactNativeTabView.TabBar, (0, _extends3['default'])({}, props, barProps));
        };
        var routes = _this2.getRoutes(props);
        _this2.state = {
            index: _this2.getIndexFromKey(),
            routes: routes
        };
        return _this2;
    }

    (0, _createClass3['default'])(Tabs, [{
        key: 'getRoutes',
        value: function getRoutes(props) {
            return _react2['default'].Children.map(props.children, function (child, idx) {
                return {
                    key: child.key || '' + idx,
                    title: child.props.tab || 'Option' + idx,
                    scene: function scene() {
                        return child.props.children;
                    }
                };
            });
        }
    }, {
        key: 'getIndexFromKey',
        value: function getIndexFromKey() {
            var _props = this.props,
                activeKey = _props.activeKey,
                defaultActiveKey = _props.defaultActiveKey;

            var key = activeKey || defaultActiveKey;
            if (!key) {
                return 0;
            }
            var routes = this.getRoutes(this.props);
            return routes.findIndex(function (r) {
                return r.key === key;
            });
        }
    }, {
        key: 'getScenes',
        value: function getScenes() {
            var routes = this.getRoutes(this.props);
            var scenes = {};
            routes.forEach(function (route) {
                scenes['' + route.key] = route.scene;
            });
            return scenes;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                animated = _props2.animated,
                swipeable = _props2.swipeable,
                tabBarPosition = _props2.tabBarPosition;

            var postionRender = (0, _defineProperty3['default'])({}, tabBarPosition === 'top' ? 'renderHeader' : 'renderFooter', this._renderBar);
            return _react2['default'].createElement(_reactNativeTabView.TabViewAnimated, (0, _extends3['default'])({ navigationState: this.state, renderScene: (0, _reactNativeTabView.SceneMap)(this.getScenes()), onIndexChange: this.handleIndexChange, animationEnabled: animated, swipeEnabled: swipeable }, postionRender));
        }
    }]);
    return Tabs;
}(_react.PureComponent);

Tabs.defaultProps = {
    tabBarPosition: 'top',
    animated: true,
    swipeable: true,
    onChange: function onChange() {},
    onTabClick: function onTabClick() {},

    underlineColor: '#ddd',
    activeUnderlineColor: '#108ee9',
    textColor: '#000',
    activeTextColor: '#108ee9',
    styles: tabsStyles,
    barStyle: null
};
Tabs.TabPane = TabPane;
exports['default'] = Tabs;